#include <mega48p.h>

char r=255,g=0,b=255,c=0,c0=0,count0=0,count1=0;
bit key=1;

interrupt [TIM0_COMPA] void timer0_compa_isr(void)
{
count0++;
if(count0==150) {
    count0=0;  
    
    //button
    if(PIND.6==0) {
        if(key) {
            if(c==6) c=c0;
            else {
                c0=c;
                c=6;
                }
            key=0;                
            }

        }
    else 
        key=1;    
    //button

    }
if(count0<r) 
    PORTC.5=1;
else 
    PORTC.5=0;
if(count0<g) 
    PORTC.4=1; 
else
    PORTC.4=0;
if(count0<b) 
    PORTC.3=1;
else
    PORTC.3=0;

}


interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
if(count1==4) {
switch (c) {
    case 0:{b--; if(b==0) c++; break;}
    case 1:{g++; if(g==255) c++; break;}
    case 2:{r--; if(r==0) c++; break;} 
    case 3:{b++; if(b==255) c++; break;}
    case 4:{g--; if(g==0) c++; break;}
    case 5:{r++; if(r==255) c=0; break;}
    case 6:break;
    }
count1=0; }
else count1++;


}



void main(void)
{

#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif


PORTB=0;
DDRB=0;

PORTC=0x00;
DDRC=0b00111000;

PORTD=0b01000001;
DDRD =0b00000010;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: CTC top=OCR0A
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x02;
TCCR0B=0x01;
TCNT0=0x00;
OCR0A=100;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: CTC top=OCR1A
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0xA0;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=FFh
// OC2A output: Disconnected
// OC2B output: Disconnected
ASSR=0x00;
TCCR2A=0x00;
TCCR2B=0x00;
TCNT2=0x00;
OCR2A=0x00;
OCR2B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-14: Off
// Interrupt on any change on pins PCINT16-23: Off
EICRA=0x00;
EIMSK=0x00;
PCICR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x02;
// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x02;
// Timer/Counter 2 Interrupt(s) initialization
TIMSK2=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;

// Global enable interrupts
#asm("sei")

while (1)
      {
      
      };
}
